_ENV = AIContext


function init_handle_production_data()
  --ships data
  init_navy_composition()

  --local num_empire_planets = 0
  --for planet ; empire.planets if not planet.no_colony
  --  num_empire_planets += 1
  --end end

  --default_reserve_budget = 5*num_empire_planets
  default_reserve_budget = 0

  --econ data
  sustainable_hammer_production = max_sustainable_hammer_production()
  desired_metal_production = desired_metal_income()

  --ground units
  mem_revolt_ratings = strong_memoizeNN | function(planet)
    local _TRACE_INFO = planet.name
    local rebel_power, defender_power = planet:calc_rebel_defender_power()
    return rebel_power, defender_power 
  end

end


function best_industry(urgent_fun)

  local planet,research,hammers

  for p ; free_planets 
    if  p.productive
      if fully_developed(p) or (urgent_fun and urgent_fun(p))
        local r = p.beaker_production
        local h = p.raw_hammer_production
        if not planet or h>hammers or (h==hammers and r<research)
          planet,research,hammers=p,r,h
        end
      end
    end
  end

  return planet

end

local function set_production()	
	
	--ra_empire.ai_state.production_desires
	--empire=em

	free_planets = {}
  urgent_buy = {}

	local nplanets=0
	for p ; empire.planets
		if not p.fixed_production
			free_planets[p] = true
			nplanets+=1
		end
	end

	planets=empire.planets
  
  --ai_debug_print("starting allocation", empire.name, nplanets, t2s | production_desires)
  

	--console("starting allocation",nplanets)

	--allocate_ra_tiles( dispatch, production_desires, nplanets )

  trade_production_dispatch()

  food_deficit_dispatch()
  metal_deficit_dispatch()

	--print(..v2s | production_desires)

  dynamic_priority_dispatch(dispatch)

  improve_remaining_planets()
  
  improvement_transmutation_dispatch()

  coin_deficit_dispatch()

	free_planets = nil

end


function handle_production()
  local _TRACE_INFO = empire.name
  --print(..empire, SCOPE["temp AI State"]?.empire)
	set_production()
	buy_things(empire)
end